#!/usr/bin/perl

use utf8;
use HTTP::Lite;
use Net::Twitter::Lite;
use Encode qw/decode decode_utf8/;
use Encode::Guess;

chdir("/home/ymda/00www/denkiyohou/htdocs");

my $cache="./cache";

my $body=&httpcl("http://denkiyohou.daiba.cx/?twitter");
my($stat,$text)=split(/,/,$body);
if(!-r "$cache/$stat.txt") {
	open(W,">$cache/$stat.txt");
	print W $text;
	close(W);

	my $twit = Net::Twitter::Lite->new(
		consumer_key => '閧',
		consumer_secret => '閧',
	);
	$twit->access_token ('閧');
	$twit->access_token_secret('閧');

	if($text ne '') {
		my $r=$twit->update(force_decode($text));
		if($@){    warn "Twitter post error.[$@]";}
	}
}

sub httpcl {
	my ($url)=shift;
	my $retry=600;
	my $http=new HTTP::Lite;
	$http->method("GET");
	$http->http11_mode(1);
	$http->add_req_header("User-Agent","denkiyohou-twitter-bot (http://denkiyohou.daiba.cx/)");
	my $loop=1;
	my $body;
	my $stat=1;
	for(my $i=0;$i<=$retry;$i++) {
		my $req=$http->request($url);
		if($req eq 200) {
			$body=$http->body();
			$stat=0;
			last;
		}
	}
	$body=~s/\x0D\x0A|\x0D|\x0A/\x0A/g;
	return($stat,$body);
}

sub force_decode($) {
	my $str = shift || '';
	my $enc = guess_encoding($str, qw/shiftjis utf8/);
	return ref $enc ? $enc->decode($str) : decode_utf8($str);
}
